﻿;28.02.2024 start work
;01.03.2024,7:41 check opcodes, fix output 8:03 fixed
;02.03.20242,9:09 GUI, fix stupid error with LSB/MSB
;02.03.20242,10:18 loadfile() 10:32 done without .rk
;03.03.2024 local labels 7:50 part call done. 8:11 multiselect done
;03.03.2024 10:28 Show bytes implemented, work on calls,10:36 continue jumps 14:42 done
;04.03.2024 8:28 add extra locals 8:35 done, undocumented 8:43-done
;05.02.2024 7:41 read files 8:02 done
;06.03.2024 7:02 save disassembly 7:24 done. add folder path,9:28 font 9:33 done

Global NewList la()
Global *m=AllocateMemory(65536)
Global *t=AllocateMemory(65536)
Global cp.u
Global start_a.u
Global fsize.u
Global b$
Global mark_a.l=-1
Global fp$=GetCurrentDirectory()

Enumeration
  #t_code
  #t_byte
  #t_word
EndEnumeration

Enumeration ; gadgets
  #d
EndEnumeration

Enumeration ; menus
  #file_open
  #file_save
  #file_quit
  #opt_undoc
  #opt_byte
  
  #mark_code
  #mark_byte
  #mark_word
EndEnumeration

Procedure.s regn(n)
  r$="unkn"
  Select n
    Case 0:r$="B"
    Case 1:r$="C"
    Case 2:r$="D"
    Case 3:r$="E"
    Case 4:r$="H"
    Case 5:r$="L"
    Case 6:r$="M"
    Case 7:r$="A"
  EndSelect
  ProcedureReturn r$
EndProcedure

Procedure.s b2s(b.a)
  ProcedureReturn RSet(Hex(b),2,"0")
EndProcedure

Procedure.s w2s(w.u)
  ProcedureReturn RSet(Hex(w),4,"0")
EndProcedure

Procedure.a getbyte()
  v.a=PeekA(*m+cp)
  cp=cp+1
  b$=b$+b2s(v)+" "
  ProcedureReturn v
EndProcedure

Procedure disas()
  curi=GetGadgetState(#d)
  ClearGadgetItems(#d)
  ClearList(la())
  pund=GetMenuItemState(0,#opt_undoc)
  For pa=0 To 1
    cp=start_a
    While cp<=start_a+fsize+1
      o$=RSet(Hex(cp),4,"0")
      b$=""
      Select PeekA(*t+cp)
        Case #t_word
          p$=" DW "+w2s(getbyte()+256*getbyte())
        Case #t_byte
          by.a=getbyte()
          p$=".BYTE "+b2s(by)
          If by>=32 And by<=127
            p$=p$+" ; "+Chr(by)
          EndIf
        Case #t_code
          op.a=getbyte()
          p$=".BYTE $"+b2s(op)
          If op>=32 And op<=127
            p$=p$+" ; "+Chr(op)
          EndIf
          Select op
            Case $08,$10,$18,$20,$28,$30,$38;NOP
              If pund
                p$="NOP ; undocumented"
              EndIf
            Case $D9 ; RET
              If pund
                p$="RET ; undocumented"
              EndIf
            Case $DD,$ED,$FD ; CALL
              If pund
                wo.u=getbyte()+256*getbyte()
                If wo>=cp And wo<=start_a+fsize+1
                  If pa=0
                    AddElement(la())
                    la() = wo
                  Else
                    p$="CALL L"+w2s(wo)+" ; undocumented"
                  EndIf
                Else
                  p$="CALL $"+w2s(wo)+" ; undocumented"
                EndIf
              EndIf
            Case $CB ; JMP
              If pund
                wo.u=getbyte()+256*getbyte()
                If wo>=cp And wo<=start_a+fsize+1
                  If pa=0
                    AddElement(la())
                    la() = wo
                  Else
                    p$="JMP L"+w2s(wo)+" ; undocumented"
                  EndIf
                Else
                  p$="JMP $"+w2s(wo)+" ; undocumented"
                EndIf
              EndIf
            Case $78 To $7F ;MOV A,
              p$="MOV A,"+regn(op-$78)
            Case $0A
              p$="LDAX B"
            Case $1A
              p$="LDAX D"
            Case $3A
              wo.u=getbyte()+256*getbyte()
              p$="LDA $"+w2s(wo)
            Case $40 To $47    ; MOV B,
              p$="MOV B,"+regn(op-$40)
            Case $48 To $4F ;MOV C,
              p$="MOV C,"+regn(op-$48)
            Case $50 To $57; MOV D,
              p$="MOV D,"+regn(op-$50)
            Case $58 To $5F ;MOV E,
              p$="MOV E,"+regn(op-$58)
            Case $60 To $67; MOV H,
              p$="MOV H,"+regn(op-$60)
            Case $68 To $6F ;MOV L,
              p$="MOV L,"+regn(op-$68)
            Case $70 To $75,$77; MOV M,
              p$="MOV M,"+regn(op-$70)
            Case $3E;MVI	A,byte	LD	A,byte		3Ebyte		A <- byte
              p$="MVI A,$"+b2s(getbyte())
            Case $06;MVI	B,byte	LD	B,byte		06byte		B <- byte
              p$="MVI B,$"+b2s(getbyte())
            Case $0E;MVI	C,byte	LD	C,byte		0Ebyte		C <- byte
              p$="MVI C,$"+b2s(getbyte())
            Case $16;MVI	D,byte	LD	D,byte		16byte		D <- byte
              p$="MVI D,$"+b2s(getbyte())
            Case $1E;MVI	E,byte	LD	E,byte		1Ebyte		E <- byte
              p$="MVI E,$"+b2s(getbyte())
            Case $26;MVI	H,byte	LD	H,byte		26byte		H <- byte
              p$="MVI H,$"+b2s(getbyte())
            Case $2E;MVI	L,byte	LD	L,byte		2Ebyte		L <- byte
              p$="MVI L,$"+b2s(getbyte())
            Case $36;MVI	M,byte	LD	(HL),byte	36byte	     (HL) <- byte
              p$="MVI M,$"+b2s(getbyte())
            Case $02;STAX	B	LD	(BC),A		02	     (BC) <- A
              p$="STAX B"
            Case $12;STAX	D	LD	(DE),A		12	     (DE) <- A
              p$="STAX D"
            Case $32;STA	word	LD	(word),A	32word	   (word) <- A   
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="STA L"+w2s(wo)
                EndIf
              Else
                p$="STA $"+w2s(wo)
              EndIf
            Case $01;LXI	B,word	LD	BC,word		01word		BC <- word
              wo.u=getbyte()+256*getbyte()
              p$="LXI B,$"+w2s(wo)
            Case $11;LXI	D,word	LD	DE,word		11word		DE <- word
              wo.u=getbyte()+256*getbyte()
              p$="LXI D,$"+w2s(wo)
            Case $21;LXI	H,word	LD	HL,word		21word		HL <- word
              wo.u=getbyte()*256+getbyte()
              p$="LXI H,$"+w2s(wo)
            Case $31;LXI	SP,word	LD	SP,word		31word		SP <- word
              wo.u=getbyte()+256*getbyte()
              p$="LXI SP,#"+w2s(wo)
            Case $2A;LHLD	word	LD	HL,(word)	2Aword		HL <- (word)
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="LHLD L"+w2s(wo)
                EndIf
              Else
                p$="LHLD $"+w2s(wo)
              EndIf
            Case $22;SHLD	word	LD	(word),HL	22word		(word) <- HL
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="SHLD L"+w2s(wo)
                EndIf
              Else
                p$="SHLD $"+w2s(wo)
              EndIf
            Case $F9;SPHL		LD	SP,HL		F9		SP <- HL
              p$="SPHL"
            Case $EB;XCHG		EX	DE,HL		EB		HL <-> DE
              p$="XCHG"
            Case $E3;XTHL		EX	(SP),HL		E3	    H <-> (SP+1); L <-> (SP)
              p$="XTHL"
            Case $80 To $87;ADD A
              p$="ADD "+regn(op-$80)
            Case $C6;ADI
              p$="ADI $"+b2s(getbyte())
            Case $88 To $8F;ADC A
              p$="ADC "+regn(op-$88)
            Case $CE;ACI
              p$="ACI $"+b2s(getbyte())
            Case $90 To $97;SUB A
              p$="SUB "+regn(op-$90)
            Case $D6;SUI
              p$="SUI $"+b2s(getbyte())
            Case $98 To $9F;SBB
              p$="SBB "+regn(op-$98)
            Case $DE;SBI
              p$="SBI $"+b2s(getbyte())
            Case $09;DAD	B	ADD	HL,BC		09		HL <- HL + BC
              p$="DAD B"
            Case $19;DAD	D	ADD	HL,DE		19		HL <- HL + DE
              p$="DAD D"
            Case $29;DAD	H	ADD	HL,HL		29		HL <- HL + HL
              p$="DAD H"
            Case $39;DAD	SP	ADD	HL,SP		39		HL <- HL + SP
              p$="DAD SP"
            Case $F3;DI		DI			F3		IFF <- 0
              p$="DI"
            Case $FB;EI		EI			FB		IFF <- 1
              p$="EI"
            Case $00;NOP		NOP			00		No Operation
              p$="NOP"
            Case $76;HLT		HLT			76		NOP;PC <- PC-1
              p$="HLT"
            Case $3C;INR	A	INC	A		3C		A <- A + 1
              p$="INR A"
            Case $04;INR	B	INC	B		04		B <- B + 1
              p$="INR B"
            Case $0C;INR	C	INC	C		0C		C <- C + 1
              p$="INR C"
            Case $14;INR	D	INC	D		14		D <- D + 1
              p$="INR D"
            Case $1C;INR	E	INC	E		1C		E <- E + 1
              p$="INR E"
            Case $24;INR	H	INC	H		24		H <- H + 1
              p$="INR H"
            Case $2C;INR	L	INC	L		2C		L <- L + 1
              p$="INR L"
            Case $34;INR	M	INC	(HL)		34		(HL) <- (HL) + 1
              p$="INR M"
            Case $3D;DCR	A	DEC	A		3D		A <- A - 1
              p$="DCR A"
            Case $05;DCR	B	DEC	B		05		B <- B - 1
              p$="DCR B"
            Case $0D;DCR	C	DEC	C		0D		C <- C - 1
              p$="DCR C"
            Case $15;DCR	D	DEC	D		15		D <- D - 1
              p$="DCR D"
            Case $1D;DCR	E	DEC	E		1D		E <- E - 1
              p$="DCR E"
            Case $25;DCR	H	DEC	H		25		H <- H - 1
              p$="DCR H"
            Case $2D;DCR	L	DEC	L		2D		L <- L - 1
              p$="DCR L"
            Case $35;DCR	M	DEC	(HL)		35		(HL) <- (HL) - 1
              p$="DCR M"
            Case $03;INX	B	INC	BC		03		BC <- BC + 1
              p$="INX B"
            Case $13;INX	D	INC	DE		13		DE <- DE + 1
              p$="INX D"
            Case $23;INX	H	INC	HL		23		HL <- HL + 1
              p$="INX H"
            Case $33;INX	SP	INC	SP		33		SP <- SP + 1
              p$="INX SP"
            Case $0B;DCX	B	DEC	BC		0B		BC <- BC - 1
              p$="DCX B"
            Case $1B;DCX	D	DEC	DE		1B		DE <- DE - 1
              p$="DCX D"
            Case $2B;DCX	H	DEC	HL		2B		HL <- HL - 1
              p$="DCX H"
            Case $3B;DCX	SP	DEC	SP		3B		SP <- SP - 1
              p$="DCX SP"
            Case $27;DAA		DAA			27		---
              p$="DAA"
            Case $2F;CMA		CPL			2F		A <- Not A
              p$="CMA"
            Case $37;STC		SCF			37		CF (Carry Flag) <- 1
              p$="STC"
            Case $3F;CMC		CCF			3F		CF (Carry Flag) <-
              p$="CMC"
            Case $07;RLC		RLCA			07		---
              p$="RLC"
            Case $0F;RRC		RRCA			0F		---
              p$="RRC"
            Case $17;RAL		RLA			17		---
              p$="RAL"
            Case $1F;RAR		RRA			1F		---
              p$="RAR"
              ;p$=""
            Case $A0 To $A7;ANA
              p$="ANA "+regn(op-$A0)
            Case $E6;ANI
              p$="ANI $"+b2s(getbyte())
              
            Case $A8 To $AF;XRA
              p$="XRA "+regn(op-$A8)
            Case $EE;XRI
              p$="XRI $"+b2s(getbyte())
              
            Case $B0 To $B7;ORA
              p$="ORA "+regn(op-$B0)
            Case $F6;ORI
              p$="ORI $"+b2s(getbyte())
              
            Case $B8 To $BF;CMP
              p$="CMP "+regn(op-$B8)
            Case $FE;CPI
              p$="CPI $"+b2s(getbyte())
              
            Case $c3;JMP	address	JP	address		C3address	PC <- address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JMP L"+w2s(wo)
                EndIf
              Else
                p$="JMP $"+w2s(wo)
              EndIf
            Case $C2;JNZ	address	JP	NZ,address	C2address   	If NZ, PC <- address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JNZ L"+w2s(wo)
                EndIf
              Else
                p$="JNZ $"+w2s(wo)
              EndIf
            Case $CA;JZ	address	JP	Z,address	CAaddress	If  Z, PC <- address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JZ L"+w2s(wo)
                EndIf
              Else
                p$="JZ $"+w2s(wo)
              EndIf
            Case $D2;JNC	address	JP	NC,address	D2address	If NC, PC <- address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JNC L"+w2s(wo)
                EndIf
              Else
                p$="JNC $"+w2s(wo)
              EndIf
            Case $DA;JC	address	JP	C,address	DAaddress	If  C, PC <- address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JC L"+w2s(wo)
                EndIf
              Else
                p$="JC $"+w2s(wo)
              EndIf
            Case $E2;JPO	address	JP	PO,address	E2address	If PO, PC <- address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JPO L"+w2s(wo)
                EndIf
              Else
                p$="JPO $"+w2s(wo)
              EndIf
            Case $EA;JPE	address	JP	PE,address	EAaddress	If PE, PC <- address
              wo.u=getbyte()*256+getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JPE L"+w2s(wo)
                EndIf
              Else
                p$="JPE $"+w2s(wo)
              EndIf
            Case $F2;JP	address	JP	P,address	F2address	If  P, PC <- address
              wo.u=getbyte()+256*getbyte()
              p$="JP "+w2s(wo)
            Case $FA;JM	address	JP	M,address	FAaddress	If  M, PC <- address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="JM L"+w2s(wo)
                EndIf
              Else
                p$="JM $"+w2s(wo)
              EndIf
            Case $E9;PCHL		JP	(HL)		E9		PC <- HL
              p$="PCHL"
            Case $CD;CALL	address	CALL	address		CDaddress  (SP-1) <- PCh;(SP-2) <- PCl
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CALL L"+w2s(wo)
                EndIf
              Else
                p$="CALL $"+w2s(wo)
              EndIf
            Case $C4;CNZ	address	CALL	NZ,address	C4address	If NZ, CALL address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CNZ L"+w2s(wo)
                EndIf
              Else
                p$="CNZ $"+w2s(wo)
              EndIf
            Case $CC;CZ	address	CALL	Z,address	CCaddress	If  Z, CALL address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CZ L"+w2s(wo)
                EndIf
              Else
                p$="CZ $"+w2s(wo)
              EndIf
            Case $D4;CNC	address	CALL	NC,address	D4address	If NC, CALL address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CNC L"+w2s(wo)
                EndIf
              Else
                p$="CNC $"+w2s(wo)
              EndIf
            Case $DC;CC	address	CALL	C,address	DCaddress	If  C, CALL address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CC L"+w2s(wo)
                EndIf
              Else
                p$="CC $"+w2s(wo)
              EndIf
            Case $E4;CPO	address	CALL	PO,address	E4address	If PO, CALL address
              wo.u=getbyte()*256+getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CPO L"+w2s(wo)
                EndIf
              Else
                p$="CPO $"+w2s(wo)
              EndIf
            Case $EC;CPE	address	CALL	PE,address	ECaddress	If PE, CALL address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CPE L"+w2s(wo)
                EndIf
              Else
                p$="CPE $"+w2s(wo)
              EndIf
            Case $F4;CP	address	CALL	P,address	F4address	If  P, CALL address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CP L"+w2s(wo)
                EndIf
              Else
                p$="CP $"+w2s(wo)
              EndIf
            Case $FC;CM	address	CALL	M,address	FCaddress	If  M, CALL address
              wo.u=getbyte()+256*getbyte()
              If wo>=cp And wo<=start_a+fsize+1
                If pa=0
                  AddElement(la())
                  la() = wo
                Else
                  p$="CM L"+w2s(wo)
                EndIf
              Else
                p$="CM L"+w2s(wo)
              EndIf
            Case $C9;RET		RET			C9	    PCl <- (SP);PCh <- (SP+1)
              p$="RET"
            Case $C0;RNZ		RET	NZ		C0		If NZ, RET
              p$="RNZ"
            Case $C8;RZ		RET	Z		C8		If  Z, RET
              p$="RZ"
            Case $D0;RNC		RET	NC		D0		If NC, RET
              p$="RNC"
            Case $D8;RC		RET	C		D8		If  C, RET
              p$="RC"
            Case $E0;RPO		RET	PO		E0		If PO, RET
              p$="RPO"
            Case $E8;RPE		RET	PE		E8		If PE, RET
              p$="RPE"
            Case $F0;RP		RET	P		F0		If  P, RET
              p$="RP"
            Case $F8;RM		RET	M		F8		If  M, RET
              p$="RM"
              
            Case $C7;RST	0	RST	0		C7		CALL	0
              p$="RST 0"
            Case $CF;RST	1	RST	8		CF		CALL	8
              p$="RST 1"
            Case $D7;RST	2	RST	10H		D7		CALL	10H
              p$="RST 2"
            Case $DF;RST	3	RST	18H		DF		CALL	18H
              p$="RST 3"
            Case $E7;RST	4	RST	20H		E7		CALL	20H
              p$="RST 4"
            Case $EF;RST	5	RST	28H		EF		CALL	28H
              p$="RST 5"
            Case $F7;RST	6	RST	30H		F7		CALL	30H
              p$="RST 6"
            Case $FF;RST	7	RST	38H		FF		CALL	38H
              p$="RST 7"
              
            Case $C5;PUSH	B	PUSH	BC		C5	(SP-2) <- C; (SP-1) <- B;
              p$="PUSH B"
            Case $D5;PUSH	D	PUSH	DE		D5	(SP-2) <- E; (SP-1) <- D;
              p$="PUSH D"
            Case $E5;PUSH	H	PUSH	HL		E5	(SP-2) <- L; (SP-1) <- H;
              p$="PUSH H"
            Case $F5;PUSH	PSW	PUSH	AF		F5	(SP-2) <- Flags; (SP-1) <- A;
              p$="PUSH PSW"
            Case $C1;POP	B	POP	BC		C1	B <- (SP+1); C <- (SP);
              p$="POP B"
            Case $D1;POP	D	POP	DE		D1	D <- (SP+1); E <- (SP);
              p$="POP D"
            Case $E1;POP	H	POP	HL		E1	H <- (SP+1); L <- (SP);
              p$="POP H"
            Case $F1;POP	PSW	POP	AF		F1	A <- (SP+1); Flags <- (SP);
              p$="POP PSW"
              
            Case $DB;IN	byte	IN	A,(byte)	DBbyte		A <- [byte]
              p$="IN $"+b2s(getbyte())
            Case $D3;OUT	byte	OUT	(byte),A	D320		[byte] <- A
              p$="OUT $"+b2s(getbyte())
          EndSelect
      EndSelect
      If pa
        ;check if addres in list
        ForEach la()
          If la()=Val("$"+o$)
            o$="L"+o$
            Break
          EndIf
        Next
        b$=RSet(Trim(b$),8," ")
        AddGadgetItem(#d,-1,o$+Chr($0A)+b$+Chr($0A)+p$)
      EndIf
    Wend
  Next pa
  SetGadgetState(#d,curi)
EndProcedure

Procedure loadfile(f$)
  FillMemory(*t,65536,#t_code)
  e$=LCase(GetExtensionPart(f$))
  fs=FileSize(f$)
  If fs>=0 And fs<65536
    If ReadFile(0,f$)
      fp$=GetPathPart(f$)
      If e$="com"
        start_a=$100
        fsize=fs
      ElseIf e$="bin"
        start_a=0
        fsize=fs
      ElseIf e$="rk"
        start_a=ReadUnicodeCharacter(0)
        fsize=ReadUnicodeCharacter(0)
      Else
        start_a=0
        fsize=0
        MessageRequester("Load File","Do not know what to load")
      EndIf
    Else
      MessageRequester("Load File","Read error:"+f$)
    EndIf;If ReadFile(0,f$)
    
    If fsize>0
      For i=0 To fsize-1
        PokeA(*m+(i+start_a)&$FFFF,ReadAsciiCharacter(0))
      Next i
      CloseFile(0)
      disas()
    EndIf;If fsize>0
  Else
    MessageRequester("load File","wrong size for "+f$)
  EndIf;If FileSize(f$)>=0 And FileSize(f$)
  
EndProcedure

Procedure markitem(type)
  ic=CountGadgetItems(#d)
  If ic
    For i=0 To ic
      If GetGadgetItemState(#d,i)=#PB_ListIcon_Selected
        a$=GetGadgetItemText(#d,i,0)
        If Mid(a$,1,1)="L"
          a$=Mid(a$,2)
        EndIf
        PokeA(*t+Val("$"+a$),type)
      EndIf
    Next i
    disas()
  EndIf
EndProcedure

;--window code
If OpenWindow(0, 0, 0, 640, 480, "i8080dis", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ListIconGadget(#d, 0, 0, 640, 400, "Adr", 60, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection|#PB_ListIcon_MultiSelect)
  AddGadgetColumn(#d, 1, "Byte", 80)
  AddGadgetColumn(#d, 2, "Code", 220)
  EnableGadgetDrop(#d,#PB_Drop_Files,#PB_Drag_Copy)
  ;--font
  If(OpenLibrary(0, "GDI32.DLL"))
    hfont=CallFunction(0, "AddFontMemResourceEx", ?font, (?end_font -?font), 0, @"1")
    LoadFont(0,"Dina",10)
    SetGadgetFont(#d,FontID(0))
    CloseLibrary(0)
  Else
    hfont=0
  EndIf 
  
  
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open..."+Chr(9)+"Ctrl+O")
    MenuItem(#file_save, "Save..."+Chr(9)+"Ctrl+S")
    MenuBar()
    MenuItem(#file_quit, "Quit")
    
    MenuTitle("Options")
    MenuItem(#opt_byte, "Show Byte column")
    MenuItem(#opt_undoc, "Undocumented opcodes")
    SetMenuItemState(0,#opt_byte,1)
    SetMenuItemState(0,#opt_undoc,1)
    AddKeyboardShortcut(0,#PB_Shortcut_Control | #PB_Shortcut_O,#file_open)
    AddKeyboardShortcut(0,#PB_Shortcut_Control | #PB_Shortcut_S,#file_save)
  EndIf
  
  If CreatePopupMenu(1)
    MenuItem(#mark_code, "Code")
    MenuItem(#mark_byte, "Byte")
    MenuItem(#mark_word, "Word")
  EndIf
  
  If CountProgramParameters()
    loadfile(ProgramParameter(0))
  EndIf
  ;loadfile("REZ.COM")
  ;loadfile("allop.bin")
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    Select Event
      Case #PB_Event_GadgetDrop
        f$=StringField(EventDropFiles(),1,Chr($0a))
        loadfile(f$)
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #d
            If EventType()=#PB_EventType_RightClick
              mnu=GetGadgetState(#d)
              If mnu<>-1
                If CountGadgetItems(#d)
                  DisplayPopupMenu(1,WindowID(0))
                EndIf
              EndIf;mnu<>-1
            EndIf  ;If EventType()=#PB_EventType_RightClick
        EndSelect
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_save
            Pattern$ = "Text (*.txt)|*.txt"
            File$ = SaveFileRequester("Please choose file to save", fp$, Pattern$, 0)
            If File$
              If LCase(Right(File$,3))<>"txt"
                File$+".txt"
              EndIf
              
              ic=CountGadgetItems(#d)
              bo=GetMenuItemState(0,#opt_byte)
              If ic
                If CreateFile(0,File$)
                  GetPathPart(File$)
                  For i=0 To ic-1
                    a$=Trim(GetGadgetItemText(#d,i,0))
                    If Mid(a$,1,1)="L"
                      WriteString(0,a$+" ",#PB_Ascii)
                    EndIf
                    If bo
                      WriteString(0,GetGadgetItemText(#d,i,1)+" ",#PB_Ascii)
                    EndIf
                    WriteStringN(0,Trim(GetGadgetItemText(#d,i,2)),#PB_Ascii)
                  Next i
                  CloseFile(0)
                Else
                  MessageRequester("Save file","File error "+File$)
                EndIf
              Else
                MessageRequester("8080dis","Empty text")
              EndIf
            EndIf
            
            
          Case #file_open
            Pattern$ = "All supported (*.bin;*.com;*.rk)|*.bin;*.com;*.rk|All files (*.*)|*.*"
            File$ = OpenFileRequester("Please choose file to load", fp$, Pattern$, 0)
            If File$
              loadfile(File$)
            EndIf
          Case #opt_undoc
            ic=1-GetMenuItemState(0,#opt_undoc)
            SetMenuItemState(0,#opt_undoc,ic)
            disas()
          Case #opt_byte
            ic=1-GetMenuItemState(0,#opt_byte)
            SetMenuItemState(0,#opt_byte,ic)
            SetGadgetItemAttribute(#d,#PB_Ignore,#PB_ListIcon_ColumnWidth,80*ic,1)
          Case #file_quit
            Break
          Case #mark_code
            markitem(#t_code)
          Case #mark_byte
            markitem(#t_byte)
          Case #mark_word
            markitem(#t_word)
        EndSelect
        
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf

FreeMemory(*t)
FreeMemory(*m)

If hfont
  If(OpenLibrary(0, "GDI32.DLL"))
    CallFunction(0, "RemoveFontMemResourceEx",hfont);<>0 if OK,0 if error
    CloseLibrary(0)
  EndIf
EndIf

DataSection
  font:
  IncludeBinary "DinaR.fon"
  end_font:

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 756
; FirstLine = 730
; Folding = --
; EnableXP
; UseIcon = 8080.ico
; Executable = 8080dis.exe
; CommandLine = allop.bin